#!/bin/sh

ICI_DIR=$(dirname $0)

pushd $ICI_DIR > /dev/null

f_check_link()
{
	printf "Create link: ${LINK} ?\\n"
	printf "[y/n] ? "
	read MAKE_LINK
	echo $MAKE_LINK
	if [ "${MAKE_LINK}" == "y"   \
	  -o "${MAKE_LINK}" == "Y"   \
	  -o "${MAKE_LINK}" == "yes" \
	  -o "${MAKE_LINK}" == "YES" ]
	then
		if [ -r "${LINK}" ]
		then
			printf "%s already exists.\\n" "${LINK}"
			printf "Delete? [y/n]: "
			read MAKE_LINK
			echo $MAKE_LINK
			if [ "${MAKE_LINK}" == "y"   \
			  -o "${MAKE_LINK}" == "Y"   \
			  -o "${MAKE_LINK}" == "yes" \
			  -o "${MAKE_LINK}" == "YES" ]
			then
				echo "OK. Deleting ${LINK}"
				rm ${LINK}
			else
				echo "OK. Not deleting ${LINK}"
				LINK=""
			fi
		fi
	else
		echo "OK. Not creating ${LINK}"
		LINK=""
	fi	
}

VERSION=$(sed VERSION -e's/ .*//')
INSTALL=/boot/apps/ici_${VERSION}
APP=./ici.beos_x86
DIFFS=./ici.beos.diffs

echo "Patching source code"
if [ -r ${DIFFS} ] 
then
	patch -p1 < ../${DIFFS} || {
		echo "*** FAILED TO PATCH SOURCE."
		echo "*** Compile may fail"
	}	
else
	echo "*** Diffs file '${DIFFS}' does not exist."
	echo "*** Cannot patch source"
	echo "*** Compile may fail"
fi	
printf "================================================\\n"
  
echo "Building application"
make -f Makefile.beos || {
	echo "*** FAILED TO BUILD APP."
	echo "*** Checking if application exists..."
	[ -r "${APP}" ] || {
		echo "*** ${APP} does not exist."
		echo "*** Exiting"
		exit 1
	}
}	
printf "================================================\\n"

echo "Testing for install directory."
if [ "${PWD}" != "${INSTALL}" ]
then
	LINK="${INSTALL}"
	f_check_link
	if [ "${LINK}" ]
	then
		echo "Linking ${PWD} as '${LINK}'"
		ln -s "${PWD}" "${LINK}"
	fi
fi
printf "================================================\\n"

LINK=/boot/home/config/bin/ici
f_check_link

if [ "${LINK}" ]
then
	echo "Creating link in ~/config/bin"
	ln -s "${INSTALL}/${APP}" "${LINK}"
fi
printf "================================================\\n"

popd > /dev/null
echo "Done"
