#include <fwd.h>
#include "func.h"

extern cfunc_t  std_cfuncs[];
extern cfunc_t  clib_cfuncs[];
extern cfunc_t  extra_cfuncs[];
extern cfunc_t	load_cfuncs[];

#ifndef NOWIN
extern cfunc_t  win_cfuncs[];
#endif
#ifndef NOTRACE
extern cfunc_t  trace_cfuncs[];
#endif
#ifndef NOSKT
extern cfunc_t  skt_cfuncs[];
#endif
#ifndef NOSYSCALL
extern cfunc_t  syscall_cfuncs[];
#endif
#ifndef NOEVENTS
extern cfunc_t  ici_event_cfuncs[];
#endif
#ifndef NOPROFILE
extern cfunc_t  ici_profile_cfuncs[];
#endif

cfunc_t *funcs[] =
{
    std_cfuncs,
    clib_cfuncs,
    extra_cfuncs,
    load_cfuncs,
#ifndef NOSYSCALL
    syscall_cfuncs,
#endif
#ifndef NOWIN
    win_cfuncs,
#endif
#ifndef NOTRACE
    trace_cfuncs,
#endif
#ifndef NOSKT
    skt_cfuncs,
#endif
#ifndef NODEBUGGING
    ici_debug_cfuncs,
#endif
#ifndef NOEVENTS
    ici_event_cfuncs,
#endif
#ifndef NOPROFILE
    ici_profile_cfuncs,
#endif
    NULL
};

/*
 * All this does is define a string to identify the version number
 * of the interpreter. Update for new releases.
 *
 * Note test for defined(_WIN32) - MS C defines __STDC__ only when in
 * strict ANSI mode (/Za option) but this causes other problems.
 *
 */
#if defined(__STDC__) || defined(_WIN32)
/*
 * Eg: @(#)ICI 2.0.1, conf-sco.h, Apr 20 1994, SCO config (math win waitfor pipes)
 */
char ici_version_string[] = "@(#)ICI 2.1.4, " CONFIG_FILE ", " __DATE__
                            ", " CONFIG_STR " ("

#ifndef NOMATH
    "math "
#endif
#ifndef NOWIN
    "win "
#endif
#ifndef NODB
    "db "
#endif
#ifndef NOTRACE
    "trace "
#endif
#ifndef NOWAITFOR
    "waitfor "
#endif
#ifndef NOSYSTEM
    "system "
#endif
#ifndef NOPIPES
    "pipes "
#endif
#ifndef NOSKT
    "sockets "
#endif
#ifndef NOSYSCALL
    "syscall "
#endif
#ifndef NODIR
    "dir "
#endif
#ifndef NOPASSWD
    "passwd "
#endif
#ifndef NODLOAD
    "dload "
#endif
#ifndef NOSTARTUPFILE
    "startupfile "
#endif
#ifndef NODEBUGGING
    "debugging "
#endif

    ")";

#else /* __STDC__ */

char ici_version_string[] = "@(#)ICI 2.1.4";

#endif
