#include "fwd.h"
#ifndef NOEVENTS
#include "exec.h"
#include "func.h"

#ifdef  _WIN32
#include <windows.h>
/*
 * Win32 specific event processing.
 */

static int
f_eventloop()
{
    MSG         msg;

    for (;;)
    {
        switch (GetMessage(&msg, NULL, 0, 0))
        {
        case 0:
            return null_ret();

        case -1:
            return ici_get_last_win32_error();
        }
        TranslateMessage(&msg);
        /*
         * We're going to dispatch this message via DispatchMessage. But
         * all sorts of handler functions outside our control return all
         * sorts of spurious values. So we use a very a specific return
         * value, plus the setting of error, to get a positive indication
         * that a real error has occured.
         */
        error = NULL;
        if (DispatchMessage(&msg) == ICI_EVENT_ERROR && error != NULL)
            return 1;
    }
}

#endif _WIN32

cfunc_t ici_event_cfuncs[] =
{
    {CF_OBJ,    "eventloop",       f_eventloop},
    {CF_OBJ}
};
#endif NOEVENTS
