#include "func.h"
#include "buf.h"
#include "struct.h"
#ifdef MULTI
#include        "multi.h"
#endif
#include "pcre/pcre.h"

wrap_t  *wraps;

extern cfunc_t  *funcs[];

/*
 * Perform basic interpreter setup.
 */
int
ici_init(void)
{
    cfunc_t             **cfp;
    struct_t            *scope;

    if (chkbuf(80))
        return 1;
    if ((atoms = (object_t **)ici_alloc(64 * sizeof(object_t *))) == NULL)
        return 1;
    atomsz = 64; /*61;*/
    memset((char *)atoms, 0, atomsz * sizeof(object_t *));
    if ((objs = (object_t **)ici_alloc(60 * sizeof(object_t *))) == NULL)
        return 1;
    memset((char *)objs, 0, 60 * sizeof(object_t *));
    objs_limit = objs + 60;
    objs_top = objs;
    o_zero = new_int(0L);
    o_one = new_int(1L);
    pcre_free = ici_raw_free;
    pcre_malloc = (void *(*)(size_t))ici_raw_alloc;
    if (init_parse())
        return 1;
    if ((scope = new_struct()) == NULL)
        return 1;
    if ((scope->s_super = new_struct()) == NULL)
        return 1;
    decref(scope->s_super);
    if (init_exec(scope))
        return 1;
    decref(scope);
    for (cfp = funcs; *cfp != NULL; ++cfp)
    {
        if (ici_assign_cfuncs(scope->s_super, *cfp))
            return 1;
    }
#ifndef NOSYSCALL
    if (syscall_mkvars(scope->s_super))
        return 1;
#endif
    return 0;
}
