#include "exec.h"
#include "pc.h"

/*
 * Mark this and referenced unmarked objects, return memory costs.
 * See comments on t_mark() in object.h.
 */
static unsigned long
mark_pc(object_t *o)
{
    o->o_flags |= O_MARK;
    return sizeof(pc_t) + mark(pcof(o)->pc_code);
}

/*
 * NB: pc's come back ready-decref'ed.
 */
pc_t *
new_pc(c)
array_t	*c;
{
    register pc_t	*pc;

    /*
     * NB: There is an in-line copy of this in exec.c
     */
    if ((pc = talloc(pc_t)) == NULL)
	return NULL;
    objof(pc)->o_type = &pc_type;
    objof(pc)->o_tcode = TC_PC;
    objof(pc)->o_flags = 0;
    objof(pc)->o_nrefs = 0;/* Pc's are pre-loosened.  Unlike other types. */
    rego(pc);
    pc->pc_code = c;
    pc->pc_next = c->a_base;
    pc->pc_limit = c->a_top;
    return pc;
}

type_t	pc_type =
{
    mark_pc,
    free_simple,
    hash_unique,
    cmp_unique,
    copy_simple,
    assign_simple,
    fetch_simple,
    "pc"
};
