#include "exec.h"
#include "src.h"

/*
 * Mark this and referenced unmarked objects, return memory costs.
 * See comments on t_mark() in object.h.
 */
static unsigned long
mark_src(object_t *o)
{
    long	mem;

    o->o_flags |= O_MARK;
    mem = sizeof(src_t);
    if (srcof(o)->s_filename != NULL)
	mem += mark(srcof(o)->s_filename);
    return mem;
}

src_t *
new_src(int lineno, string_t *filename)
{
    register src_t	*s;

    if ((s = talloc(src_t)) == NULL)
	return NULL;
    objof(s)->o_type = &src_type;
    objof(s)->o_tcode = TC_SRC;
    objof(s)->o_flags = 0;
    objof(s)->o_nrefs = 1;
    rego(s);
    s->s_lineno = lineno;
    s->s_filename = filename;
    return s;
}

type_t	src_type =
{
    mark_src,
    free_simple,
    hash_unique,
    cmp_unique,
    copy_simple,
    assign_simple,
    fetch_simple,
    "src"
};
