#include <fwd.h>

#ifndef	NOWIN
/*
 * Terminfo or termcap loading and conditioning.
 */
#ifndef	MSDOS

#ifdef M_XENIX
#ifdef	TERMINFO
#undef M_TERMCAP
#define	M_TERMINFO
#else
#undef	M_TERMINFO
#define M_TERMCAP
#endif
#endif


#include "acs.h"
#include "exec.h"
#include "func.h"
#include "int.h"
#include "wrap.h"
#include "buf.h"

#ifdef	NeXT
#   include <sgtty.h>
#   define	termio	sgttyb
#   define	TCSETAW	TIOCSETP
#   define	TCGETA	TIOCGETP
#else
#   if defined(linux)
#	include <sys/ioctl.h>
#	include <unistd.h>
#	include <termcap.h>
#	include <termio.h>
#	define termio termios
#   elif defined(SUNOS5)
#	include <sys/ioctl.h>
#	include <unistd.h>
#	include <sys/termio.h>
#	undef	HUPCL
#	undef	TIOCHPCL
#	undef	TIOCGETP
#	undef	TIOCSETP
#	undef	TIOCEXCL
#	undef	TIOCNXCL
#	include <curses.h>
#	undef	strchr
#	undef	strrchr
#	include <term.h>
#   else
#	ifndef	BSD
#	    include <termio.h>
#	else
#	    include <sys/termio.h>
#	endif
#   endif
#endif

#include <signal.h>
#include <errno.h>

#ifdef	TERMINFO
#include <curses.h>
#ifndef	BSD
#include <term.h>
#endif
#define	tgoto(x, c, l)	tparm(x, l, c)
#endif

extern char	*tgoto();

void		ti_nocanon(void);

#ifndef TI_PUTC_ARG
#define	TI_PUTC_ARG	int
#endif

/*
 * Imports from win.c
 */
extern int	ti_putc(TI_PUTC_ARG);
extern char	*ti_clear;
extern char	*ti_cup;
extern int	ti_ncols;
extern int	ti_nlines;
extern int	ti_automargins;
extern char	*ti_smacs;
extern char	*ti_rmacs;
extern int	ti_gotocost;
extern char	ti_acsmap[];
extern char	ti_defmap[];
/*
 * This must be in sync with the #defines in acs.h and the other maps in
 * win.c
 */
static char	*ti_acsc;
static char	ti_vt100acs[]	= " +,.0I-'a  fghjklmnoqstuvwx~";

struct termio	orig_tty;	/* The modes we came in with. */
static void	(*orig_sigint)();/* Likewise. */
static int	orig_valid;	/* If the orig_tty structure is filled in. */
static int	ti_not_canon;	/* Currently not in canonical mode. */

struct key
{
    char	*k_name;
    char	*k_tiname;
    char 	*k_code;
};

#if 0
static char		kfmt[]	= "kf%d";
#endif
static struct key	keys[] =
{
#ifdef	TERMINFO
	{"F0", kfmt},	{"F1", kfmt},	{"F2", kfmt},	{"F3", kfmt},
	{"F4", kfmt},	{"F5", kfmt},	{"F6", kfmt},	{"F7", kfmt},
	{"F8", kfmt},	{"F9", kfmt},	{"F10", kfmt},	{"F11", kfmt},
	{"F12", kfmt},	{"F13", kfmt},	{"F14", kfmt},	{"F15", kfmt},
	{"F16", kfmt},	{"F17", kfmt},	{"F18", kfmt},	{"F19", kfmt},
	{"F20", kfmt},	{"F21", kfmt},	{"F22", kfmt},	{"F23", kfmt},
	{"F24", kfmt},	{"F25", kfmt},	{"F26", kfmt},	{"F27", kfmt},
	{"F28", kfmt},	{"F29", kfmt},	{"F30", kfmt},	{"F31", kfmt},
	{"F32", kfmt},

	{"UP",		"kcuu1"},
	{"DOWN",	"kcud1"},
	{"LEFT",	"kcub1"},
	{"RIGHT",	"kcuf1"},
	{"HOME",	"khome"},
	{"END",		"kend"},
	{"PGUP",	"kpp"},
	{"PGDOWN",	"knp"},
#else /* Termcap. */
	{"F0", "k0"},	{"F1", "k1"},	{"F2", "k2"},	{"F3", "k3"},
	{"F4", "k4"},	{"F5", "k5"},	{"F6", "k6"},	{"F7", "k7"},
	{"F8", "k8"},	{"F9", "k9"},	{"F10", "k;"},	{"F11", "F1"},
	{"F12", "F2"},	{"F13", "F3"},	{"F14", "F4"},	{"F15", "F5"},
	{"F16", "F6"},	{"F17", "F7"},	{"F18", "F8"},	{"F19", "F9"},
	{"F20", "FA"},	{"F21", "FB"},	{"F22", "FC"},	{"F23", "FD"},
	{"F24", "FE"},	{"F25", "FF"},	{"F26", "FG"},	{"F27", "FH"},
	{"F28", "FI"},	{"F29", "FJ"},	{"F30", "FK"},	{"F31", "FL"},
	{"F32",	"FM"},

	{"UP",		"ku"},
	{"DOWN",	"kd"},
	{"LEFT",	"kl"},
	{"RIGHT",	"kr"},
	{"HOME",	"kh"},
	{"END",		"@7"},
	{"PGUP",	"kP"},
	{"PGDOWN",	"kN"},
#endif
};

#ifndef	TERMINFO
static int
ti_getstrs(p)
register char	**p;
{
    extern char		*tgetstr();
    register int	i;

    if ((ti_clear = tgetstr("cl", p)) == (char *)-1)
	return 1;
    if ((ti_cup = tgetstr("cm", p)) == NULL)
	return 1;
    for (i = 0; i < nels(keys); ++i)
	keys[i].k_code = tgetstr(keys[i].k_tiname, p);
    ti_smacs = tgetstr("as", p);
    ti_rmacs = tgetstr("ae", p);
    ti_acsc = tgetstr("ac", p);
    return 0;
}
#endif

/*
 * Returns 0 on successful terminal setup, 1 on failure.
 */
int
ti_init()
{
    static int		setup_done;

#ifdef	TERMINFO
    int			errret;

    if (setup_done)
	return 0;
    if (setupterm(NULL, 0, &errret) == ERR)
	goto fail;
    if ((ti_clear = tigetstr("clear")) == (char *)-1)
	goto fail;
    if ((ti_cup = tigetstr("cup")) == (char *)-1)
	goto fail;
    if ((ti_smacs = tigetstr("smacs")) == (char *)-1)
	goto fail;
    if ((ti_rmacs = tigetstr("rmacs")) == (char *)-1)
	goto fail;
    if ((ti_acsc = tigetstr("acsc")) == (char *)-1)
	goto fail;
    if ((ti_automargins = tigetflag("am")) == -1)
	goto fail;
    if ((ti_nlines = tigetnum("lines")) == -2)
	goto fail;
    if ((ti_ncols = tigetnum("cols")) == -2)
	goto fail;
    /*
     * Get the codes for the function keys (etc.)
     */
    for (i = 0; i < nels(keys); ++i)
    {
	if (chkbuf(strlen(keys[i].k_tiname) + 10))
	    goto fail;
	sprintf(buf, keys[i].k_tiname, i);
	if ((keys[i].k_code = tigetstr(buf)) == (char *)-1)
	    keys[i].k_code = NULL;
    }
#else /* Not terminfo, so must be termcap... */
    char		*term_name;
    char		*term_ptr;
    char		term_buf[10240];
    char		term_area[10240];
    extern char		*getenv();

    if (setup_done)
	return 0;
    if ((term_name = getenv("TERM")) == NULL)
	goto fail;
    if (tgetent(term_buf, term_name) != 1)
	goto fail;
    /*
     * Get the strings twice, once to work out how much room we need, then
     * to store them in the allocated area.
     */
    term_ptr = term_area;
    if (ti_getstrs(&term_ptr))
	goto fail;
    if ((term_ptr = ici_alloc(term_ptr - term_area)) == NULL)
	return 1;
    if (ti_getstrs(&term_ptr))
	goto fail;

    /*
     * And the other entries...
     */
    ti_automargins = tgetflag("am");
    if ((ti_nlines = tgetnum("li")) == -1)
	goto fail;
    if ((ti_ncols = tgetnum("co")) == -1)
	goto fail;
#endif

    ti_gotocost = strlen(tgoto(ti_cup, 10, 10));

    if (ti_acsc != NULL)
    {
	register char	*p;
	register char	*q;

	for (p = ti_acsc + strlen(ti_acsc) - 2; p > ti_acsc; p -= 2)
	{
	    if ((q = strchr(ti_vt100acs, p[0])) != NULL)
		ti_acsmap[q - ti_vt100acs] = p[1];
	}
	for (p = ti_defmap; *p != '\0'; ++p)
	{
	    if (ti_acsmap[p - ti_defmap] == '\0')
		ti_acsmap[p - ti_defmap] = *p;
	}
    }

    ti_nocanon();
    return 0;

fail:
    error = "could not setup terminal interface";
    return 1;
}


void
ti_catch()
{
    wrapup(); /* Will cause ti_canon(). */
    if (ti_cup != NULL)
    {
	ti_putc('\0');	/* End any in-progress sequences. */
	ti_putc('\0');
	ti_putc('\0');
	ti_putc('\0');
	tputs(ti_rmacs, 1, ti_putc);	/* Out of any graphics char set. */
	tputs(tgoto(ti_cup, 0, ti_nlines - 1), 1, ti_putc); /* Bottom left. */
    }
    exit(1);
}

/*
 * Set the terminal back to plain ordinary ascii terminal.
 */
int
ti_canon()
{
    if (orig_valid != 1 || ti_not_canon == 0)
	return 0;
    ioctl(0, TCSETAW, &orig_tty);
    signal(SIGINT, orig_sigint);
    ti_not_canon = 0;
    return 0;
}

/*
 * Turn off canonical input processing.
 */
void
ti_nocanon()
{
    struct termio	tty;
    static wrap_t	wrap;

    if (wrap.w_func == NULL)
    {
	wrap.w_func = ti_canon;
	wrap.w_next = wraps;
	wraps = &wrap;
    }
    if (orig_valid == 0)
    {
	if (ioctl(0, TCGETA, &orig_tty) == -1)
	    orig_valid = -1;
	else
	    orig_valid = 1;
    }
    if ((orig_sigint = signal(SIGINT, ti_catch)) != SIG_DFL)
	signal(SIGINT, orig_sigint);
    tty = orig_tty;
#ifdef	NeXT
    tty.sg_flags &= ~(ECHO);
    tty.sg_flags |= (CBREAK);
#else
    tty.c_oflag &= ~OPOST;
    tty.c_lflag &= ~(ICANON|ECHO);
    tty.c_iflag &= ~(ICRNL|INLCR);
    tty.c_cc[VEOF] = 1;
    tty.c_cc[VEOL] = 0;
#endif
    ioctl(0, TCSETAW, &tty);
    ti_not_canon = 1;
}

static void
getch_timeout()
{
}

char *
ti_getchar()
{
    register int	i;
    register int	c = 0;
    char		ch;
    int			gotone;
    int			ngot;
    static char 	gotc[16];
    char		couldbe[nels(keys)];
    void		(*oldsig)() = 0;
    int			oldalarm = 0;
    static int		pending = -1;

    if (pending != -1)
    {
	gotc[0] = pending;
	gotc[1] = '\0';
	pending = -1;
	return gotc;
    }
    for (i = 0; i < nels(couldbe); ++i)
	couldbe[i] = keys[i].k_code != NULL;
    ngot = 0;
    do
    {
	if (ngot > 0)
	{
	    if ((oldsig = signal(SIGALRM, getch_timeout)) != SIG_ERR)
		oldalarm = alarm(1);
	}
	if (read(0, &ch, 1) < 0)
	{
	    if (errno != EINTR)
	    {
		error = "can't read standard input";
		return NULL;
	    }
	    break;
	}
	if (ngot > 0)
	{
	    if (oldsig != SIG_ERR)
	    {
		alarm(0);
		signal(SIGALRM, oldsig);
		if (--oldalarm < 0)
		    oldalarm = 0;
		else if (oldalarm == 0)
		    oldalarm = 1;
		alarm(oldalarm);
	    }
	}
	c = ch;

	gotone = 0;
	for (i = 0; i < nels(couldbe); ++i)
	{
	    if (!couldbe[i] || (keys[i].k_code[ngot] & 0xFF) != c)
	    {
		couldbe[i] = 0;
		continue;
	    }
	    gotone = 1;
	    if (keys[i].k_code[ngot + 1] == '\0')
		return keys[i].k_name;
	}
	gotc[ngot++] = c;

    } while (gotone);

    if (ngot > 1)
	pending = c;
    else
	pending = -1;
    gotc[1] = '\0';
    return gotc;
}
#endif /* MSDOS */
#endif
